VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()

Dim ctoki As Cryptoki
Dim ckiinfo As CryptokiInfo
Dim info As TokenInfo
Dim slots As SlotList
Dim slt As Slot
Dim sltInfo As SlotInfo
Dim ret As Long
Dim tkn As Token
Dim tknInfo As TokenInfo
Dim sess As Session
Dim sessInfo As Session
Dim objs As CryptokiObjects
Dim I As Integer

' Creates new Cryptoki object
Set ctoki = New Cryptoki

' attach to pkcs11 module
ret = ctoki.Attach("vcki.dll")

On Error Resume Next
ctoki.Finalize (0)
On Error GoTo 0

' initialize
ret = ctoki.Initialize_2(False)



Set ckiinfo = ctoki.info

'MsgBox (info.LibDescription)

Set slots = ctoki.slots

For Each slt In slots

MsgBox (slt.info.Description)

Next

Set slt = slots.GetSlot(1)
    
Set sltInfo = slt.info

Do While Not sltInfo.IsTokenPresent
    MsgBox ("Insert Smart Card")
    ctoki.WaitForSlotEvent (0)
Loop


Set tkn = slt.Token

Set tknInfo = tkn.info

Set sess = tkn.OpenSession(CKF_RW_SESSION Or CKF_SERIAL_SESSION)

sess.Login CKU_USER, "64005666"

Set objs = sess.Objects

Dim attrListPub As CryptokiCollection
Dim attrListPri As CryptokiCollection
Dim mech As Mechanism
Dim att As ObjectAttribute


Set attrListPub = New CryptokiCollection

Set attrListPri = New CryptokiCollection

' creates attributes object
Set att = New ObjectAttribute
att.Set CKA_CLASS, CKO_PUBLIC_KEY
attrListPub.Add att

Set att = New ObjectAttribute
att.Set CKA_TOKEN, True
attrListPub.Add att

Set att = New ObjectAttribute
att.Set CKA_PRIVATE, True
attrListPub.Add att

Set att = New ObjectAttribute
att.Set CKA_ENCRYPT, True
attrListPub.Add att

Set att = New ObjectAttribute
att.Set CKA_LABEL, "My Key"
attrListPub.Add att


' creates attributes object
Set att = New ObjectAttribute
att.Set CKA_CLASS, CKO_PRIVATE_KEY
attrListPri.Add att

Set att = New ObjectAttribute
att.Set CKA_TOKEN, True
attrListPri.Add att

Set att = New ObjectAttribute
att.Set CKA_PRIVATE, True
attrListPri.Add att

Set att = New ObjectAttribute
att.Set CKA_DECRYPT, True
attrListPri.Add att

Set att = New ObjectAttribute
att.Set CKA_LABEL, "My Key"
attrListPri.Add att
'Dim a() As Byte
'Dim b() As Byte
'Set a = sess.Encrypt(b)

Dim rando() As Byte
rando = sess.GenerateRandom(10)

Set mech = New Mechanism
Dim val(1) As Byte

val(0) = 1
mech.Set CKM_RSA_PKCS_KEY_PAIR_GEN, val(0)

Dim pubKey As PublicKey
Dim priKey As PrivateKey
Dim key() As key

key = sess.GenerateKeyPair(mech, attrListPub, attrListPri)

Set pubKey = key(0)
Set priKey = key(1)

' Find Object
Dim attrList As CryptokiCollection

Set att = New ObjectAttribute
att.Set CKA_CLASS, CKO_PUBLIC_KEY
attrList.Add att

Set att = New ObjectAttribute
att.Set CKA_TOKEN, True
attrList.Add att

Set att = New ObjectAttribute
att.Set CKA_PRIVATE, True
attrList.Add att

Dim objList As CryptokiCollection
Set objList = objs.Find(attrList, 4)

MsgBox ("Found : " & objList.Count)

' prepare buffer to encrypt
Dim toEncrypt(10) As Byte
Dim encrypted() As Byte

For I = 0 To 10
toEncrypt(I) = &H41 ' A
Next

mech.Set CKM_RSA_PKCS, Nothing

sess.EncryptInit mech, objList.Item(0)

encrypted = sess.Encrypt(toEncrypt(0))

End Sub

